#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <string.h>

#define FWD 0xAA
#define REV 0x55
#define R 0x22
#define L 0x88
#define RSPEED OCR1AL
#define LSPEED OCR1BL
#define SPEED 255

void move (unsigned char dir,unsigned char power) 
{
	PORTC=dir;
	if(dir == L)
	{
		LSPEED=power;RSPEED=0;
	}
	else if (dir == R) 
	{
		RSPEED=power;LSPEED=0;
	}
	else if (dir == FWD)
	{
		LSPEED=RSPEED=power;
	}
	else if (dir == REV)
	{
		LSPEED=RSPEED=-power;
	}
}

void main(void)
{
	// Input/Output Ports initialization
	// Port A initialization
	PORTA=0x00;
	DDRA=0x00;
	// Port B initialization
	PORTB=0x00;
	DDRB=0x00;
	// Port C initialization
	PORTC=0x00;
	DDRC=0xFF;
	// Port D initialization
	PORTD=0x00;
	DDRD=0x30;
	// Timer/Counter 0 initialization
	TCCR0=0x00;
	TCNT0=0x00;
	OCR0=0x00;
	// Timer/Counter 1 initialization
	TCCR1A=0xA1;
	TCCR1B=0x0A;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0xFF;
	OCR1BH=0x00;
	OCR1BL=0xFF;
	// Timer/Counter 2 initialization
	ASSR=0x00;
	TCCR2=0x00;Line Follower
	Page 13 of 17
	TCNT2=0x00;
	OCR2=0x00;
	// External Interrupt(s) initialization
	MCUCR=0x00;
	MCUCSR=0x00;

	// Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK=0x00;
	
	while (1)
	{
		// move right
		if (((PINA &(1<<0))==0) move(R,SPEED);
		// move left
		else if (((PINB &(1<<0))==0) move(L,SPEED);
		//move forward
		else if (((PINC &(1<<0)) ==  0) move(FWD,SPEED);
		//move backward
		else if (((PIND &(1<<0)) ==  0) move(REF,SPEED);
	};
	
	return 0;
}